package cz.muni.fi.pb138.dtd_to_xsd;

import java.io.InputStream;
import java.util.List;
import java.util.Map;

/**
 * Created by IntelliJ IDEA.
 * Author: Roman Jakubco 374241
 * Date: 20.4.2012
 * Time: 17:30
 */
public interface DTDCutter {
    /**
     * method gets ALL elementst from given stream formated
     * <!ELEMENT TVSCHEDULE (CHANNEL+)>
     *
     * @param  sourceDTD
     * @return List<String> contains all Elements from given stream
     */
    public List<String> getElementsFromSource(InputStream sourceDTD);

    /**
     * method gets ALL attributes from given stream formated
     * <!ATTLIST TVSCHEDULE NAME CDATA #REQUIRED>
     *
     * @param  sourceDTD
     * @return List<String> contains all Attributes from given stream
     */
    public List<String> getAttributesFromSource(InputStream sourceDTD);

    /**
     * method gets ALL entities from given stream formated
     * <!ENTITY entity-name SYSTEM "URI/URL">
     *
     * @param sourceDTD
     * @return List<String> contains all Entities from given stream
     */
    public List<String> getEntitiesFromSource(InputStream sourceDTD);

    /**
     * method gets doctype from given stream formated
     * <!DOCTYPE NEWSPAPER>
     *
     * @param  sourceDTD
     * @return String doctype
     */
    public String getDoctypeFromSource(InputStream sourceDTD);


    /**
     * method returns Map containing following keys: elements,attributes,entities,doctype
     * //////////////////////
     * nevim, jak k tomuhle dat dohromady smysluplny javadoc, nekdo schopnejsi to snad dopise.
     * Medota v podstate vraci cely dokument rozdelene na elementy,atributy, entity a doctype
     * //////////////////////
     * @param sourceDTD
     * @return
     */
    public Map<String,List<String>> getDTDFromSource(InputStream sourceDTD);


}
